blob: 7ebbce4bdbaf243a7a5612c024216b8ccf8eae44 [file] [log] [blame]
Junio C Hamano91063bb2005-09-08 13:47:12 -07001#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
Shawn O. Pearcef9474132006-12-28 02:34:48 -05006USAGE='[-n] [--no-commit] [--squash] [-s <strategy>] [-m=<merge-message>] <commit>+'
Junio C Hamano17bcdad2006-11-20 01:06:09 -08007
Junio C Hamano533b7032007-01-12 12:52:03 -08008SUBDIRECTORY_OK=Yes
Junio C Hamanoae2b0f12005-11-24 00:12:11 -08009. git-sh-setup
Shawn O. Pearce7eff28a2006-12-30 23:32:38 -050010require_work_tree
Junio C Hamano533b7032007-01-12 12:52:03 -080011cd_to_toplevel
Junio C Hamano91063bb2005-09-08 13:47:12 -070012
Junio C Hamanod1014a12006-12-31 23:21:50 -080013test -z "$(git ls-files -u)" ||
Junio C Hamano533b7032007-01-12 12:52:03 -080014 die "You are in the middle of a conflicted merge."
Junio C Hamanod1014a12006-12-31 23:21:50 -080015
Junio C Hamano91063bb2005-09-08 13:47:12 -070016LF='
17'
18
Junio C Hamano68faf682007-02-15 16:32:45 -080019all_strategies='recur recursive octopus resolve stupid ours subtree'
Junio C Hamanoa06f6782006-09-24 19:49:47 -070020default_twohead_strategies='recursive'
Junio C Hamano6ea23342006-03-18 14:50:53 -080021default_octopus_strategies='octopus'
Junio C Hamano68faf682007-02-15 16:32:45 -080022no_trivial_merge_strategies='ours subtree'
Junio C Hamano91063bb2005-09-08 13:47:12 -070023use_strategies=
Junio C Hamano6ea23342006-03-18 14:50:53 -080024
25index_merge=t
Junio C Hamano91063bb2005-09-08 13:47:12 -070026
Junio C Hamanoa9358242005-09-23 00:43:04 -070027dropsave() {
Junio C Hamanodeca7e82005-09-25 00:12:06 -070028 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
Junio C Hamanoa9358242005-09-23 00:43:04 -070029 "$GIT_DIR/MERGE_SAVE" || exit 1
30}
31
32savestate() {
Junio C Hamano60fa0562005-09-28 16:29:11 -070033 # Stash away any local modifications.
Chris Shoemaker50b8e352005-10-28 13:04:49 -040034 git-diff-index -z --name-only $head |
Fredrik Kuivinen88f8f0a2005-10-03 08:13:09 +020035 cpio -0 -o >"$GIT_DIR/MERGE_SAVE"
Junio C Hamanoa9358242005-09-23 00:43:04 -070036}
37
38restorestate() {
Junio C Hamanodeca7e82005-09-25 00:12:06 -070039 if test -f "$GIT_DIR/MERGE_SAVE"
40 then
Junio C Hamano228e2eb2006-12-22 15:21:55 -080041 git reset --hard $head >/dev/null
Junio C Hamanodeca7e82005-09-25 00:12:06 -070042 cpio -iuv <"$GIT_DIR/MERGE_SAVE"
43 git-update-index --refresh >/dev/null
44 fi
Junio C Hamano91063bb2005-09-08 13:47:12 -070045}
46
Junio C Hamano7d0c6882006-06-23 01:37:02 -070047finish_up_to_date () {
48 case "$squash" in
49 t)
50 echo "$1 (nothing to squash)" ;;
51 '')
52 echo "$1" ;;
53 esac
54 dropsave
55}
56
57squash_message () {
58 echo Squashed commit of the following:
59 echo
60 git-log --no-merges ^"$head" $remote
61}
62
Junio C Hamano4f692b12005-10-22 04:45:15 -070063finish () {
Shawn Pearcee1447e32006-07-11 01:52:54 -040064 if test '' = "$2"
65 then
Shawn O. Pearcef9474132006-12-28 02:34:48 -050066 rlogm="$GIT_REFLOG_ACTION"
Shawn Pearcee1447e32006-07-11 01:52:54 -040067 else
68 echo "$2"
Shawn O. Pearcef9474132006-12-28 02:34:48 -050069 rlogm="$GIT_REFLOG_ACTION: $2"
Shawn Pearcee1447e32006-07-11 01:52:54 -040070 fi
Junio C Hamano7d0c6882006-06-23 01:37:02 -070071 case "$squash" in
72 t)
73 echo "Squash commit -- not updating HEAD"
74 squash_message >"$GIT_DIR/SQUASH_MSG"
Junio C Hamano4f692b12005-10-22 04:45:15 -070075 ;;
Junio C Hamano7d0c6882006-06-23 01:37:02 -070076 '')
77 case "$merge_msg" in
78 '')
79 echo "No merge message -- not updating HEAD"
80 ;;
81 *)
Shawn Pearcee1447e32006-07-11 01:52:54 -040082 git-update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
Junio C Hamano7d0c6882006-06-23 01:37:02 -070083 ;;
84 esac
Junio C Hamano4f692b12005-10-22 04:45:15 -070085 ;;
86 esac
Junio C Hamano7d0c6882006-06-23 01:37:02 -070087 case "$1" in
Junio C Hamano91063bb2005-09-08 13:47:12 -070088 '')
Junio C Hamano7d0c6882006-06-23 01:37:02 -070089 ;;
90 ?*)
91 case "$no_summary" in
92 '')
93 git-diff-tree --stat --summary -M "$head" "$1"
94 ;;
95 esac
Junio C Hamano91063bb2005-09-08 13:47:12 -070096 ;;
97 esac
98}
99
Junio C Hamanob1bfcae2006-12-16 12:31:45 -0800100merge_name () {
101 remote="$1"
102 rh=$(git-rev-parse --verify "$remote^0" 2>/dev/null) || return
103 bh=$(git-show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
104 if test "$rh" = "$bh"
105 then
106 echo "$rh branch '$remote' of ."
107 elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
108 git-show-ref -q --verify "refs/heads/$truname" 2>/dev/null
109 then
110 echo "$rh branch '$truname' (early part) of ."
Michael S. Tsirkin85295a52007-03-22 11:07:30 +0200111 elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
112 then
113 sed -e 's/ not-for-merge / /' -e 1q \
114 "$GIT_DIR/FETCH_HEAD"
Junio C Hamanob1bfcae2006-12-16 12:31:45 -0800115 else
116 echo "$rh commit '$remote'"
117 fi
118}
119
Rene Scharfefc61e312006-10-21 20:51:04 +0200120case "$#" in 0) usage ;; esac
121
Shawn O. Pearcef9474132006-12-28 02:34:48 -0500122have_message=
Junio C Hamano91063bb2005-09-08 13:47:12 -0700123while case "$#" in 0) break ;; esac
124do
125 case "$1" in
126 -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
127 --no-summa|--no-summar|--no-summary)
128 no_summary=t ;;
Junio C Hamano7d0c6882006-06-23 01:37:02 -0700129 --sq|--squ|--squa|--squas|--squash)
130 squash=t no_commit=t ;;
Junio C Hamano123ee3c2005-11-01 19:30:11 -0800131 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
132 no_commit=t ;;
Junio C Hamano91063bb2005-09-08 13:47:12 -0700133 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
134 --strateg=*|--strategy=*|\
135 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
136 case "$#,$1" in
137 *,*=*)
Dennis Stosberg8096fae2006-06-27 18:54:26 +0200138 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
Junio C Hamanof88ed172005-09-12 22:20:42 -0700139 1,*)
Junio C Hamano91063bb2005-09-08 13:47:12 -0700140 usage ;;
141 *)
142 strategy="$2"
143 shift ;;
144 esac
145 case " $all_strategies " in
146 *" $strategy "*)
147 use_strategies="$use_strategies$strategy " ;;
148 *)
149 die "available strategies are: $all_strategies" ;;
150 esac
151 ;;
Junio C Hamano17bcdad2006-11-20 01:06:09 -0800152 -m=*|--m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
153 merge_msg=`expr "z$1" : 'z-[^=]*=\(.*\)'`
154 have_message=t
155 ;;
156 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
157 shift
158 case "$#" in
159 1) usage ;;
160 esac
161 merge_msg="$1"
162 have_message=t
163 ;;
Junio C Hamano91063bb2005-09-08 13:47:12 -0700164 -*) usage ;;
165 *) break ;;
166 esac
167 shift
168done
169
Junio C Hamano17bcdad2006-11-20 01:06:09 -0800170# This could be traditional "merge <msg> HEAD <commit>..." and the
171# way we can tell it is to see if the second token is HEAD, but some
172# people might have misused the interface and used a committish that
173# is the same as HEAD there instead. Traditional format never would
174# have "-m" so it is an additional safety measure to check for it.
175
176if test -z "$have_message" &&
177 second_token=$(git-rev-parse --verify "$2^0" 2>/dev/null) &&
178 head_commit=$(git-rev-parse --verify "HEAD" 2>/dev/null) &&
179 test "$second_token" = "$head_commit"
180then
181 merge_msg="$1"
182 shift
183 head_arg="$1"
184 shift
Junio C Hamanoc1751612006-11-26 22:19:42 -0800185elif ! git-rev-parse --verify HEAD >/dev/null 2>&1
Junio C Hamano8092c7f2006-11-21 21:13:28 -0800186then
187 # If the merged head is a valid one there is no reason to
188 # forbid "git merge" into a branch yet to be born. We do
189 # the same for "git pull".
190 if test 1 -ne $#
191 then
192 echo >&2 "Can merge only exactly one commit into empty head"
193 exit 1
194 fi
195
196 rh=$(git rev-parse --verify "$1^0") ||
197 die "$1 - not something we can merge"
198
199 git-update-ref -m "initial pull" HEAD "$rh" "" &&
200 git-read-tree --reset -u HEAD
201 exit
202
Junio C Hamano17bcdad2006-11-20 01:06:09 -0800203else
204 # We are invoked directly as the first-class UI.
205 head_arg=HEAD
206
207 # All the rest are the commits being merged; prepare
208 # the standard merge summary message to be appended to
209 # the given message. If remote is invalid we will die
210 # later in the common codepath so we discard the error
211 # in this loop.
212 merge_name=$(for remote
213 do
Junio C Hamanob1bfcae2006-12-16 12:31:45 -0800214 merge_name "$remote"
Junio C Hamano17bcdad2006-11-20 01:06:09 -0800215 done | git-fmt-merge-msg
216 )
217 merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
218fi
219head=$(git-rev-parse --verify "$head_arg"^0) || usage
Junio C Hamano91063bb2005-09-08 13:47:12 -0700220
221# All the rest are remote heads
Junio C Hamano6ea23342006-03-18 14:50:53 -0800222test "$#" = 0 && usage ;# we need at least one remote head.
Junio C Hamano7f9acb22007-01-26 15:09:02 -0800223set_reflog_action "merge $*"
Junio C Hamano6ea23342006-03-18 14:50:53 -0800224
Junio C Hamano9954f5b2005-12-13 17:01:23 -0800225remoteheads=
Junio C Hamano91063bb2005-09-08 13:47:12 -0700226for remote
227do
Junio C Hamano51901e92006-11-26 22:16:31 -0800228 remotehead=$(git-rev-parse --verify "$remote"^0 2>/dev/null) ||
Junio C Hamano91063bb2005-09-08 13:47:12 -0700229 die "$remote - not something we can merge"
Junio C Hamano9954f5b2005-12-13 17:01:23 -0800230 remoteheads="${remoteheads}$remotehead "
Shawn O. Pearcee0ec1812006-12-23 03:44:47 -0500231 eval GITHEAD_$remotehead='"$remote"'
232 export GITHEAD_$remotehead
Junio C Hamano91063bb2005-09-08 13:47:12 -0700233done
Junio C Hamano9954f5b2005-12-13 17:01:23 -0800234set x $remoteheads ; shift
Junio C Hamano91063bb2005-09-08 13:47:12 -0700235
Junio C Hamano6ea23342006-03-18 14:50:53 -0800236case "$use_strategies" in
237'')
238 case "$#" in
239 1)
Tom Princee0d10e12007-01-28 16:16:53 -0800240 var="`git-config --get pull.twohead`"
Shawn O. Pearcede811942006-12-28 02:35:05 -0500241 if test -n "$var"
242 then
243 use_strategies="$var"
244 else
245 use_strategies="$default_twohead_strategies"
246 fi ;;
Junio C Hamano6ea23342006-03-18 14:50:53 -0800247 *)
Tom Princee0d10e12007-01-28 16:16:53 -0800248 var="`git-config --get pull.octopus`"
Shawn O. Pearcede811942006-12-28 02:35:05 -0500249 if test -n "$var"
250 then
251 use_strategies="$var"
252 else
253 use_strategies="$default_octopus_strategies"
254 fi ;;
Junio C Hamano6ea23342006-03-18 14:50:53 -0800255 esac
256 ;;
257esac
258
259for s in $use_strategies
260do
Junio C Hamanode6f0de2007-02-16 15:08:25 -0800261 for nt in $no_trivial_merge_strategies
262 do
263 case " $s " in
264 *" $nt "*)
265 index_merge=f
266 break
267 ;;
268 esac
269 done
Junio C Hamano6ea23342006-03-18 14:50:53 -0800270done
271
Junio C Hamano13956672005-11-09 18:54:14 -0800272case "$#" in
2731)
274 common=$(git-merge-base --all $head "$@")
275 ;;
276*)
277 common=$(git-show-branch --merge-base $head "$@")
278 ;;
279esac
Junio C Hamano91063bb2005-09-08 13:47:12 -0700280echo "$head" >"$GIT_DIR/ORIG_HEAD"
281
Junio C Hamano6ea23342006-03-18 14:50:53 -0800282case "$index_merge,$#,$common,$no_commit" in
283f,*)
284 # We've been told not to try anything clever. Skip to real merge.
285 ;;
286?,*,'',*)
Fredrik Kuivinen88f8f0a2005-10-03 08:13:09 +0200287 # No common ancestors found. We need a real merge.
Junio C Hamano91063bb2005-09-08 13:47:12 -0700288 ;;
Junio C Hamano6ea23342006-03-18 14:50:53 -0800289?,1,"$1",*)
Junio C Hamano91063bb2005-09-08 13:47:12 -0700290 # If head can reach all the merge then we are up to date.
Junio C Hamano6ea23342006-03-18 14:50:53 -0800291 # but first the most common case of merging one remote.
Junio C Hamano7d0c6882006-06-23 01:37:02 -0700292 finish_up_to_date "Already up-to-date."
Junio C Hamano91063bb2005-09-08 13:47:12 -0700293 exit 0
294 ;;
Junio C Hamano6ea23342006-03-18 14:50:53 -0800295?,1,"$head",*)
Junio C Hamano91063bb2005-09-08 13:47:12 -0700296 # Again the most common case of merging one remote.
Santi Béjarba0ac362006-10-01 05:34:17 +0200297 echo "Updating $(git-rev-parse --short $head)..$(git-rev-parse --short $1)"
Junio C Hamano91063bb2005-09-08 13:47:12 -0700298 git-update-index --refresh 2>/dev/null
J. Bruce Fieldsbe242d52007-03-11 12:28:56 -0400299 msg="Fast forward"
300 if test -n "$have_message"
301 then
302 msg="$msg (no commit created; -m option ignored)"
303 fi
Santi Béjar2be08a82007-03-16 11:46:09 +0100304 new_head=$(git-rev-parse --verify "$1^0") &&
305 git-read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
J. Bruce Fieldsbe242d52007-03-11 12:28:56 -0400306 finish "$new_head" "$msg" || exit
Junio C Hamanoa9358242005-09-23 00:43:04 -0700307 dropsave
Junio C Hamano91063bb2005-09-08 13:47:12 -0700308 exit 0
309 ;;
Junio C Hamano6ea23342006-03-18 14:50:53 -0800310?,1,?*"$LF"?*,*)
Junio C Hamano91063bb2005-09-08 13:47:12 -0700311 # We are not doing octopus and not fast forward. Need a
312 # real merge.
313 ;;
Junio C Hamano6ea23342006-03-18 14:50:53 -0800314?,1,*,)
Junio C Hamanof9d72412005-10-02 11:13:44 -0700315 # We are not doing octopus, not fast forward, and have only
Shawn O. Pearcec82d7112006-12-28 02:35:34 -0500316 # one common.
Junio C Hamanof9d72412005-10-02 11:13:44 -0700317 git-update-index --refresh 2>/dev/null
Shawn O. Pearcec82d7112006-12-28 02:35:34 -0500318 case " $use_strategies " in
319 *' recursive '*|*' recur '*)
320 : run merge later
321 ;;
322 *)
323 # See if it is really trivial.
324 git var GIT_COMMITTER_IDENT >/dev/null || exit
325 echo "Trying really trivial in-index merge..."
326 if git-read-tree --trivial -m -u -v $common $head "$1" &&
327 result_tree=$(git-write-tree)
328 then
329 echo "Wonderful."
330 result_commit=$(
331 echo "$merge_msg" |
332 git-commit-tree $result_tree -p HEAD -p "$1"
333 ) || exit
334 finish "$result_commit" "In-index merge"
335 dropsave
336 exit 0
337 fi
338 echo "Nope."
339 esac
Junio C Hamanof9d72412005-10-02 11:13:44 -0700340 ;;
Junio C Hamano91063bb2005-09-08 13:47:12 -0700341*)
342 # An octopus. If we can reach all the remote we are up to date.
343 up_to_date=t
344 for remote
345 do
Junio C Hamano13956672005-11-09 18:54:14 -0800346 common_one=$(git-merge-base --all $head $remote)
Junio C Hamano91063bb2005-09-08 13:47:12 -0700347 if test "$common_one" != "$remote"
348 then
349 up_to_date=f
350 break
351 fi
352 done
353 if test "$up_to_date" = t
354 then
Junio C Hamano7d0c6882006-06-23 01:37:02 -0700355 finish_up_to_date "Already up-to-date. Yeeah!"
Junio C Hamano91063bb2005-09-08 13:47:12 -0700356 exit 0
357 fi
358 ;;
359esac
360
Junio C Hamanoe3b59a42006-02-18 20:51:26 -0800361# We are going to make a new commit.
362git var GIT_COMMITTER_IDENT >/dev/null || exit
363
Junio C Hamanoa9358242005-09-23 00:43:04 -0700364# At this point, we need a real merge. No matter what strategy
365# we use, it would operate on the index, possibly affecting the
366# working tree, and when resolved cleanly, have the desired tree
367# in the index -- this means that the index must be in sync with
Junio C Hamano60fa0562005-09-28 16:29:11 -0700368# the $head commit. The strategies are responsible to ensure this.
Junio C Hamano91063bb2005-09-08 13:47:12 -0700369
Junio C Hamanoa9358242005-09-23 00:43:04 -0700370case "$use_strategies" in
371?*' '?*)
372 # Stash away the local changes so that we can try more than one.
373 savestate
374 single_strategy=no
375 ;;
376*)
Junio C Hamanodeca7e82005-09-25 00:12:06 -0700377 rm -f "$GIT_DIR/MERGE_SAVE"
Junio C Hamanoa9358242005-09-23 00:43:04 -0700378 single_strategy=yes
379 ;;
380esac
Junio C Hamano91063bb2005-09-08 13:47:12 -0700381
382result_tree= best_cnt=-1 best_strategy= wt_strategy=
Junio C Hamano695bf722005-12-23 15:48:09 -0800383merge_was_ok=
Junio C Hamano91063bb2005-09-08 13:47:12 -0700384for strategy in $use_strategies
385do
386 test "$wt_strategy" = '' || {
387 echo "Rewinding the tree to pristine..."
Junio C Hamanoa9358242005-09-23 00:43:04 -0700388 restorestate
Junio C Hamano91063bb2005-09-08 13:47:12 -0700389 }
Junio C Hamanoa9358242005-09-23 00:43:04 -0700390 case "$single_strategy" in
391 no)
392 echo "Trying merge strategy $strategy..."
393 ;;
394 esac
395
396 # Remember which strategy left the state in the working tree
Junio C Hamano91063bb2005-09-08 13:47:12 -0700397 wt_strategy=$strategy
Junio C Hamanoa9358242005-09-23 00:43:04 -0700398
Junio C Hamano123ee3c2005-11-01 19:30:11 -0800399 git-merge-$strategy $common -- "$head_arg" "$@"
400 exit=$?
401 if test "$no_commit" = t && test "$exit" = 0
402 then
Junio C Hamano695bf722005-12-23 15:48:09 -0800403 merge_was_ok=t
Junio C Hamano123ee3c2005-11-01 19:30:11 -0800404 exit=1 ;# pretend it left conflicts.
405 fi
406
407 test "$exit" = 0 || {
Junio C Hamano91063bb2005-09-08 13:47:12 -0700408
409 # The backend exits with 1 when conflicts are left to be resolved,
410 # with 2 when it does not handle the given merge at all.
411
Junio C Hamano91063bb2005-09-08 13:47:12 -0700412 if test "$exit" -eq 1
413 then
414 cnt=`{
415 git-diff-files --name-only
416 git-ls-files --unmerged
417 } | wc -l`
418 if test $best_cnt -le 0 -o $cnt -le $best_cnt
419 then
420 best_strategy=$strategy
421 best_cnt=$cnt
422 fi
423 fi
424 continue
425 }
426
427 # Automerge succeeded.
428 result_tree=$(git-write-tree) && break
429done
430
431# If we have a resulting tree, that means the strategy module
432# auto resolved the merge cleanly.
433if test '' != "$result_tree"
434then
Junio C Hamano6ea23342006-03-18 14:50:53 -0800435 parents=$(git-show-branch --independent "$head" "$@" | sed -e 's/^/-p /')
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700436 result_commit=$(echo "$merge_msg" | git-commit-tree $result_tree $parents) || exit
Shawn Pearcee1447e32006-07-11 01:52:54 -0400437 finish "$result_commit" "Merge made by $wt_strategy."
Junio C Hamanoa9358242005-09-23 00:43:04 -0700438 dropsave
Junio C Hamano91063bb2005-09-08 13:47:12 -0700439 exit 0
440fi
441
442# Pick the result from the best strategy and have the user fix it up.
443case "$best_strategy" in
444'')
Junio C Hamanoa9358242005-09-23 00:43:04 -0700445 restorestate
Junio C Hamano0c4e95d2006-12-13 09:32:40 -0800446 case "$use_strategies" in
447 ?*' '?*)
448 echo >&2 "No merge strategy handled the merge."
449 ;;
450 *)
451 echo >&2 "Merge with strategy $use_strategies failed."
452 ;;
453 esac
Fredrik Kuivinen4275df52005-12-03 11:40:21 +0100454 exit 2
Junio C Hamano91063bb2005-09-08 13:47:12 -0700455 ;;
456"$wt_strategy")
457 # We already have its result in the working tree.
458 ;;
459*)
460 echo "Rewinding the tree to pristine..."
Junio C Hamanoa9358242005-09-23 00:43:04 -0700461 restorestate
Junio C Hamano91063bb2005-09-08 13:47:12 -0700462 echo "Using the $best_strategy to prepare resolving by hand."
Junio C Hamanoa9358242005-09-23 00:43:04 -0700463 git-merge-$best_strategy $common -- "$head_arg" "$@"
Junio C Hamano91063bb2005-09-08 13:47:12 -0700464 ;;
465esac
Junio C Hamano7d0c6882006-06-23 01:37:02 -0700466
467if test "$squash" = t
468then
469 finish
470else
471 for remote
472 do
473 echo $remote
474 done >"$GIT_DIR/MERGE_HEAD"
475 echo "$merge_msg" >"$GIT_DIR/MERGE_MSG"
476fi
Junio C Hamanodeca7e82005-09-25 00:12:06 -0700477
Junio C Hamano695bf722005-12-23 15:48:09 -0800478if test "$merge_was_ok" = t
479then
480 echo >&2 \
481 "Automatic merge went well; stopped before committing as requested"
482 exit 0
483else
Junio C Hamano6b94f1e2006-01-27 23:05:05 -0800484 {
485 echo '
486Conflicts:
487'
488 git ls-files --unmerged |
489 sed -e 's/^[^ ]* / /' |
490 uniq
491 } >>"$GIT_DIR/MERGE_MSG"
Junio C Hamano1536dd9c62006-02-11 18:55:43 -0800492 if test -d "$GIT_DIR/rr-cache"
493 then
494 git-rerere
495 fi
Junio C Hamano50ac7402006-04-19 14:54:27 -0700496 die "Automatic merge failed; fix conflicts and then commit the result."
Junio C Hamano695bf722005-12-23 15:48:09 -0800497fi